Unit DE34R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE28RS_p, UTDE12_p;

procedure DE34R(F :Proc_F_DE; M :Integer; IORDER :Integer;
                XN :Real; var YN :Array of Real;
                var DYN :Array of Real; HMIN :Real; EPS :Real;
                P :Real; var H :Real; var X :Real;
                var YX :Array of Real; var DY :Array of Real;
                var DF :Array of Real; var RFN :Array of Real;
                var RF :Array of Real; var R :Array of Real;
                var IERR :Integer);

implementation

procedure DE34R(F :Proc_F_DE; M :Integer; IORDER :Integer;
                XN :Real; var YN :Array of Real;
                var DYN :Array of Real; HMIN :Real; EPS :Real;
                P :Real; var H :Real; var X :Real;
                var YX :Array of Real; var DY :Array of Real;
                var DF :Array of Real; var RFN :Array of Real;
                var RF :Array of Real; var R :Array of Real;
                var IERR :Integer);
var
I,J1,J,L,K,K1 :Integer;
RH,R1 :Real;
BUL,BUL1 :Boolean;
A :Array [0..5] of Real;
D :Array [0..3] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
{   DATA  FORTRAN  }
A[0] := 6.0;
A[1] := 2.0;
A[2] := 1.5;
A[3] := 1.266666666666667;
A[4] := 1.125;
A[5] := 0.95;
D[0] := 1.0;
D[1] := -4.0;
D[2] := 6.0;
D[3] := -4.0;
IERR := 0;
BUL1 := False;
RH := IntPower(H,2)/12.0;
_1:
F(XN,YN,RFN,M);
for I:=1 to M do
 begin
  RFN[I-1] := RFN[I-1]*RH;
  DY[I-1] := H*DYN[I-1]+A[0]*RFN[I-1];
  YX[I-1] := YN[I-1]+DY[I-1];
_2:
 end;
X := XN+H;
F(X,YX,DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*RH;
  DF[(I-1)+1*M] := DF[(I-1)+0*M]-RFN[I-1];
  YX[I-1] := YX[I-1]+DY[I-1]+12.0*DF[(I-1)+0*M];
_3:
 end;
X := X+H;
F(X,YX,RF,M);
for I:=1 to M do
 begin
  RF[I-1] := RF[I-1]*RH;
_4:
 end;
J1 := 3;
DE28RS(M,J1,RF,DF,R);
for I:=1 to M do
 begin
  DF[(I-1)+1*M] := DF[(I-1)+1*M]-2.0*DF[(I-1)+2*M];
  YX[I-1] := YN[I-1]+H*DYN[I-1]+A[0]*RFN[I-1]+A[1]*DF[(I-1)+1*M]+A[2]*
    DF[(I-1)+2*M];
_5:
 end;
X := XN+H;
F(X,YX,DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*RH;
  DF[(I-1)+1*M] := DF[(I-1)+0*M]-RFN[I-1];
  DY[I-1] := YX[I-1]-YN[I-1];
_6:
 end;
for J:=2 to 4 do
 begin
  X := X+H;
  for I:=1 to M do
   begin
    DY[I-1] := DY[I-1]+12.0*DF[(I-1)+0*M]+DF[(I-1)+2*M];
    YX[I-1] := YX[I-1]+DY[I-1];
_7:
   end;
  F(X,YX,RF,M);
  for I:=1 to M do
   begin
    RF[I-1] := RF[I-1]*RH;
_8:
   end;
  J1 := J+1;
  DE28RS(M,J1,RF,DF,R);
_9:
 end;
for I:=1 to M do
 begin
  for L:=2 to 5 do
   begin
    R1 := 0.0;
    for K:=L to 5 do
     begin
      K1 := K-L+1;
      R1 := R1+DF[(I-1)+(K-1)*M]*D[K1-1];
_10:
     end;
    DF[(I-1)+(L-1)*M] := R1;
_11:
   end;
  DF[(I-1)+0*M] := RFN[I-1];
  DY[I-1] := H*DYN[I-1]+A[0]*RFN[I-1]+A[1]*DF[(I-1)+1*M]+A[2]*DF[(I-1)+2*M]+
    A[3]*DF[(I-1)+3*M]+A[4]*DF[(I-1)+4*M];
  YX[I-1] := YN[I-1]+DY[I-1];
  for K:=1 to 4 do
   begin
    L := 5-K;
    DF[(I-1)+(L-1)*M] := DF[(I-1)+(L-1)*M]+DF[(I-1)+(L+0)*M];
_12:
   end;
_13:
 end;
X := XN+H;
for I:=1 to M do
 begin
  R[I-1] := DF[(I-1)+4*M];
  if ( Abs(YX[I-1]) <= P ) 
   then goto _14;
  R[I-1] := R[I-1]/YX[I-1];
_14:
  R[I-1] := R[I-1]*A[5];
  if ( Abs(R[I-1]) > EPS ) 
   then goto _16;
_15:
 end;
goto _18;
_16:
if ( not BUL1 ) 
 then goto _17;
IERR := 65;
goto _18;
_17:
H := H*0.5;
BUL := False;
RH := RH/4.0;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _1;
H := Sign(HMIN,H);
RH := IntPower(H,2)/12.0;
BUL1 := True;
goto _1;
_18:
if ( IERR <> 0 ) 
 then UTDE12(IERR,34);
end;

end.
